/* Toggle Led  
   by Simon Pauw (2015)
   Toggles the value of a led on the press of a button */

/* Global variables */
int ledPin = 3;
int buttonPin = 2;
int ledValue = LOW;
int previousButtonValue = HIGH;

/* Run at startup (only runs once) */
void setup() {

  Serial.begin(9600);
  // Set buttonPin as input (configured to be HIGH if not connected)
  pinMode(buttonPin, INPUT);
  
  pinMode(ledPin, OUTPUT);
}

/* Loop is run after setup() and is repeated forever */
void loop() {
  // Read the state of the button. 
  // LOW: Button is pressed, HIGH: Button NOT pressed 
  int buttonValue = digitalRead(buttonPin);
  
  // If buttonValue CHANGES from LOW to HIGH 
  if(buttonValue == LOW && previousButtonValue == HIGH) {
    // Toggle led
    toggleLed();
  }

  Serial.println(ledValue);
  digitalWrite(ledPin, ledValue);  
  // Remember button value 
  previousButtonValue = buttonValue;
  
  delay(50);
}

/* Toggle led switches led ON if it was OFF, 
   and OFF if it was ON */
void toggleLed() {
  if(ledValue == LOW) {
    ledValue = HIGH;
  } else {
    ledValue = LOW;
  }
}
